classdef truss2dMinCompliance_1 < truss2d 
    properties(GetAccess = 'public', SetAccess = 'private')
        myInitialVolume;
        myInitialArea;
        myInitialCompliance;
        myFinalArea;
        myFinalCompliance;
        myFinalVolume;
    end
    methods
        function obj = truss2dMinCompliance_1(xy,connectivity)
            obj = obj@truss2d(xy,connectivity);
        end
        function J = complianceObjective(obj,x)
            Area = x.*obj.myInitialArea;
            obj = obj.assignA(Area);
            obj = obj.assemble();
            obj = obj.solve();
            J = obj.getCompliance();
        end  
        function obj = assignYieldStress(obj,~,~)
            % dummy function
        end
        function obj = initialize(obj)
            obj.myInitialArea = obj.myArea;
            obj.myInitialVolume = sum(obj.myArea.*obj.myL);
            obj = obj.assemble();
            obj = obj.solve();
            obj.myInitialCompliance =  obj.getCompliance(); 
        end
        function obj = optimize(obj)
            % initialize quantities of interest
            obj = obj.initialize();
            x0 = ones(1,obj.myNumTrussBars); % unitless quantities 
            LB = 1e-12*ones(1,obj.myNumTrussBars); % small non-zero values
            AinEq = obj.myInitialArea.*obj.myL;
            BinEq = obj.myInitialVolume; 
            [xMin,~,~,Output] = fmincon(@obj.complianceObjective,x0, ...
                   AinEq,BinEq,[],[],LB);
            obj = obj.assignA(xMin.*obj.myInitialArea);
            obj = obj.assemble();
            obj = obj.solve();
            obj.myFinalArea = obj.myArea.*obj.myL;
            obj.myFinalVolume = sum(obj.myArea.*obj.myL);
            obj.myFinalCompliance =  obj.getCompliance(); 
            disp(Output)
        end
    end
end

