function [g] = complexVariableGradient(f,x0,h)
% Compute, via complex variable method,
% the gradient of f at p0
N = numel(x0);
g = zeros(N,1); % initialize memory
if (nargin == 2)
    h = 1e-12;
end
for i = 1:N
    z = x0;
    z(i) = z(i) + sqrt(-1)*h;
    fVal = feval(f,z);
    g(i) = imag(fVal)/h;
end