%Finite Difference Study of Cantilever Beam
close all;
nElements = 300;
L = 2.0;%length
H = 1;%height
d = 0.2; % length of force edge

a = 0.2; %try (0.1, 0.35) and (0.2, 0.4)
b = 0.4;

cantilever.vertices = [b 0;0 -b; 0 -H/2;L-a -H/2;L -H/2+a; L -d/2; L d/2; L H/2-a; L-a H/2; 0 H/2; 0 b ]';
cantilever.edges = [1 2; 2 3; 3 4; 4 5; 5 6; 6 7; 7 8; 8 9; 9 10; 10 11; 11 1];
fem = TriElasticity(cantilever,nElements);
fem = fem.setYoungsModulus(3.05e7);
fem = fem.setPoissonsRatio(0.28);
fem = fem.fixEdge([2,10]);
fem = fem.applyYForceOnEdge(6,-1000);
fem = fem.assemble();
fem = fem.solve();
J0 = fem.computeCompliance();

figure; fem.plotMesh();
a0 = a;
b0 = b;
derivative = [];
delta = [];
counter = 1;
for k = 2:8
    delta(counter) = 10^(-k);
    a = a0;
    b = b0 + delta(counter);
    cantilever.vertices = [b 0;0 -b; 0 -H/2;L-a -H/2;L -H/2+a; L -d/2; L d/2; L H/2-a; L-a H/2; 0 H/2; 0 b ]';
    cantilever.edges = [1 2; 2 3; 3 4; 4 5; 5 6; 6 7; 7 8; 8 9; 9 10; 10 11; 11 1];
    fem = TriElasticity(cantilever,nElements);
    fem = fem.setYoungsModulus(3.05e7);
    fem = fem.setPoissonsRatio(0.28);
    fem = fem.fixEdge([2,10]);
    fem = fem.applyYForceOnEdge(6,-1000);
    fem = fem.assemble();
    fem = fem.solve();
    J = fem.computeCompliance();
    derivative(counter) = (J-J0)/delta(counter);
    counter= counter+1;
end
figure; fem.plotMesh();
figure;
semilogx(delta,derivative);
