clc;

% illustrates linear conjugate gradient
% works only for quadratic problems

testNd = testFunctionsND;
f = @(xBar)testNd.f1(xBar);

% algorithm
x0 = [0 0];
[fVal,g0,H] = f(x0); % first step I need Hessian

d0 = g0;
% first line search
[x1] = lineSearchNR(@(xBar)f(xBar),x0,d0);

[fVal,g1] = f(x1);
beta = -d0'*H*g1/(d0'*H*d0);
d1 = g1 + beta*d0;
% second line search
[x2] = lineSearchNR(@(xBar)f(xBar),x1,d1);


[fVal,g2] = f(x2);
beta = -d1'*H*g2/(d1'*H*d1);
d2 = g2 + beta*d1;
% second line search
[x3] = lineSearchNR(@(xBar)f(xBar),x2,d2);
