function [f,g,H] = simpleTwoSpring(uv)
u = uv(1);
v = uv(2);
k12 = 100;% stiffness of spring 1
k13 = 50; % stiffness of spring 2
f =  0.5*k13*(sqrt(u^2+(1-v)^2) -1).^2 + 0.5*k12*(sqrt(u^2+(1+v)^2) -1).^2 - (10*u+8*v); 
g(1) = (k13*u*(((v - 1)^2 + u^2)^(1/2) - 1))/((v - 1)^2 + u^2)^(1/2) + (k12*u*(((v + 1)^2 + u^2)^(1/2) - 1))/((v + 1)^2 + u^2)^(1/2) - 10;
g(2) = (k13*(((v - 1)^2 + u^2)^(1/2) - 1)*(2*v - 2))/(2*((v - 1)^2 + u^2)^(1/2)) + (k12*(((v + 1)^2 + u^2)^(1/2) - 1)*(2*v + 2))/(2*((v + 1)^2 + u^2)^(1/2)) - 8;
H = zeros(2,2);
H(1,1) = (k13*u^2)/((v - 1)^2 + u^2) + (k12*u^2)/((v + 1)^2 + u^2) + (k13*(((v - 1)^2 + u^2)^(1/2) - 1))/((v - 1)^2 + u^2)^(1/2) + (k12*(((v + 1)^2 + u^2)^(1/2) - 1))/((v + 1)^2 + u^2)^(1/2) - (k13*u^2*(((v - 1)^2 + u^2)^(1/2) - 1))/((v - 1)^2 + u^2)^(3/2) - (k12*u^2*(((v + 1)^2 + u^2)^(1/2) - 1))/((v + 1)^2 + u^2)^(3/2);
H(2,2) = (k13*(2*v - 2)^2)/(4*((v - 1)^2 + u^2)) + (k12*(2*v + 2)^2)/(4*((v + 1)^2 + u^2)) + (k13*(((v - 1)^2 + u^2)^(1/2) - 1))/((v - 1)^2 + u^2)^(1/2) + (k12*(((v + 1)^2 + u^2)^(1/2) - 1))/((v + 1)^2 + u^2)^(1/2) - (k13*(((v - 1)^2 + u^2)^(1/2) - 1)*(2*v - 2)^2)/(4*((v - 1)^2 + u^2)^(3/2)) - (k12*(((v + 1)^2 + u^2)^(1/2) - 1)*(2*v + 2)^2)/(4*((v + 1)^2 + u^2)^(3/2));
H(1,2) = (k13*u*(2*v - 2))/(2*((v - 1)^2 + u^2)) + (k12*u*(2*v + 2))/(2*((v + 1)^2 + u^2)) - (k13*u*(((v - 1)^2 + u^2)^(1/2) - 1)*(2*v - 2))/(2*((v - 1)^2 + u^2)^(3/2)) - (k12*u*(((v + 1)^2 + u^2)^(1/2) - 1)*(2*v + 2))/(2*((v + 1)^2 + u^2)^(3/2));
H(2,1) = H(1,2);