
close all;
clear s;
format long
s = twoSpring();
fun = @(uv) s.potentialEnergy(uv);
method = 1;
if (method == 1) % NewtonRaphson
    opt = setDefaultOptimizationOptions();
    opt.TolX = 1e-6;
    opt.TolFun = 1e-6;
    opt.TolGrad = 1e-6;
    opt.MaxFunEvals = 1000;
    x0 = [0.1 0.1]'; % Hessian is not invertible at the origin
    [soln,fStationary,flag,output] = fStationaryNR(fun,x0,opt)
elseif (method == 2)
    opt = optimset('fminunc');
    opt = optimset(opt,'GradObj','on'); % you can pass this to fminunc
    [soln,PEMin,Flag,Output]= fminunc(fun, [0 0],opt) 
elseif (method == 3)
    [soln,PEMin,Flag,Output]= fminsearch(fun, [0 0]) 
elseif (method == 4)
    [soln,PEMin,Flag,Output]= fsolve(fun, [0 0])
end
disp(soln)
s = s.setUVAtNode(1,soln);
s.plotDeformed();
