close all;
format long
example = 1;
if (example == 1)
    f = @(xVec)(xVec(1)^2 + xVec(2)^2);
    Aeq = [1 1];
    beq = 1;
    Aineq = [];
    bineq = [];
    x0 = [0 0];
    [xMin,fMin,flag,output,lambda] = fmincon(f,x0,Aineq,bineq,Aeq,beq);
elseif (example == 2)
    f = @(xVec) xVec(1)^2 + xVec(2)^2;
    Aeq = [];
    beq = [];
    Aineq = [];
    bineq = [];
    x0 = [0 0];
    LB = [];
    UB = [];
    [xMin,fMin,flag,output,lambda] = fmincon(f,x0,Aineq,bineq,...
        Aeq,beq,LB,UB,@(xVec)constraintEquality(xVec)); 
elseif (example == 3)
    x0 = [0 0 0];
    [xStationary] = fsolve(@(xVec)stationaryPointEquations(xVec),x0);
elseif (example == 4)
    f = @(xVec) xVec(1)^2 + xVec(2)^2 + xVec(3)^2;
    Aineq = [-1 -1 -1; 1 2 3];
    bineq = [-3 4];
    Aeq = [];
    beq = [];
    x0 = [0 0 0];
    [xMin,fMin,flag,output,lambda] = fmincon(f,x0,Aineq,bineq,Aeq,beq);
elseif (example == 5)
    f = @(xVec) xVec(1)^2 + xVec(2)^2;
    Aeq = [];
    beq = [];
    Aineq = [];
    bineq = [];
    x0 = [2 0];
    LB = [];
    UB = [];
    [xMin,fMin,flag,output,lambda] = fmincon(f,x0,Aineq,bineq,...
        Aeq,beq,LB,UB,@(xVec)constraintInequality(xVec));
elseif (example == 6)
    f = @(xVec) xVec(1)^2 + xVec(2)^2;
    Aineq = [];
    bineq = [];
    x0 = [2 0];
    LB = [];
    UB = [];
    [xMin,fMin,flag,output] = fminsearchcon(f,x0,LB,UB,Aineq,bineq,...
       @(xVec)constraintInequality(xVec));   
elseif (example == 7)
    s = twoSpringWithConstraints();
    s.plot(); % plot spring without deformation
    opt = setDefaultOptimizationOptions();
    opt.GradObj = 'off';
    opt.GradConstr = 'off';
    Aeq = [];
    beq = [];
    Aineq = [];
    bineq = [];
    x0 = [0 0];
    LB = [];
    UB = [];
    [xMin,fMin,flag,output,lambda]= fmincon(@(x)s.potentialEnergy(x), [0 0],Aineq,bineq,...
        Aeq,beq,LB,UB,@(x)s.constraintsEquality(x),opt);
    %[soln,PEMin,Flag,Output]= fminsearchcon(@(x)s.potentialEnergy(x), [0 0],[],[],[],[],@(x)s.constraintsInequality(x));
    disp(xMin)
    s = s.setUVAtNode(1,xMin);
    s.plotDeformed();
    u = -1:0.01:1;
    v = u.^3;
    plot(u,v,':b');
    
elseif (example == 8)
    eq = equalityConstrainedProblems;
    f = @(pts)eq.thomsonProblemObjective(pts);
    N = 8;
    pts0 = rand(3,N);
    constr = @(pts)eq.thomsonProblemConstraint(pts);
    opt = setDefaultOptimizationOptions();
    opt = optimset(opt,'MaxFunEvals',50000);
    [ptsMin, fMin,flag,output] = fmincon(f,pts0,[],[],[],[],[],[],constr,opt);
    sphere; hold on;
    plot3(ptsMin(1,:),ptsMin(2,:),ptsMin(3,:),'*r');axis equal;
elseif (example == 9)
    f = @(xVec) xVec(1)^2 + xVec(2)^2 + xVec(3)^2;
    Aineq = [-1 -1 -1];
    bineq = [-3];
    Aeq = [0 2 3];
    beq = [4];
    x0 = [0 0 0];
    [xMin,fMin,flag,output,lambda] = fmincon(f,x0,Aineq,bineq,Aeq,beq);
elseif (example == 10)
    f = @(xVec)(xVec(1)^2 + xVec(2)^2 + xVec(3)^2);
    Aeq = [1 2 3; 2 4 6];
    beq = [1 2];
    Aineq = [];
    bineq = [];
    x0 = [0 0 0];
    [xMin,fMin,flag,output,lambda] = fmincon(f,x0,Aineq,bineq,Aeq,beq);
elseif (example == 11)
    f = @(xVec) xVec(1)^2 + xVec(2)^2;
    Aeq = [1 0];
    beq = [1];
    Aineq = [];
    bineq = [];
    x0 = [0 0];
    LB = [];
    UB = [];
    [xMin,fMin,flag,output,lambda] = fmincon(f,x0,Aineq,bineq,...
        Aeq,beq,LB,UB,@(xVec)constraintEquality(xVec)); 
elseif (example == 12)
    f = @(xVec) xVec(1)^2 + xVec(2)^2;
    Aeq = [];
    beq = [];
    Aineq = [];
    bineq = [];
    x0 = [0 0];
    LB = [];
    UB = [];
    [xMin,fMin,flag,output,lambda] = fmincon(f,x0,Aineq,bineq,...
        Aeq,beq,LB,UB,@(xVec)constraintEqualitySquared(xVec)); 
end
xMin
fMin
output.funcCount
lambda